﻿Imports UndoRedoCommand

Public Class CompositeCommand
    Implements ICommand
    Private _Commands() As ICommand
    Private _Name As String

    Public Sub New(aName As String, ParamArray Commands() As ICommand)
        _Name = aName
        _Commands = Commands
    End Sub
    Public ReadOnly Property IsCollapsible(aCommand As ICommand) As Boolean Implements ICommand.IsCollapsible
        Get
            Return False
        End Get
    End Property

    Public ReadOnly Property Name As String Implements ICommand.Name
        Get
            Return _Name
        End Get
    End Property

    Public Sub Execute() Implements ICommand.Execute
        For Each cmd As ICommand In _Commands
            cmd.Execute()
        Next
    End Sub

    Public Sub Undo() Implements ICommand.Undo
        For Each cmd As ICommand In _Commands
            cmd.Undo()
        Next
    End Sub

    Public Sub Redo() Implements ICommand.Redo
        Execute()
    End Sub

    Public Sub Collapse(aCommand As ICommand) Implements ICommand.Collapse
        '
    End Sub
End Class
