﻿Imports UndoRedoCommand

Public Class DepositCommand
    Implements ICommand
    Public ReadOnly Property Account() As Account
    Public ReadOnly Property Amount As Double

    Public Sub New(aAccount As Account, ByVal aAmount As Double)
        _Account = aAccount
        _Amount = aAmount
    End Sub

    Public ReadOnly Property IsCollapsible(aCommand As ICommand) As Boolean Implements ICommand.IsCollapsible
        Get
            If aCommand.GetType = Me.GetType AndAlso DirectCast(aCommand, DepositCommand).Account Is Account Then
                Return True
            End If
            Return False
        End Get
    End Property

    Public ReadOnly Property Name As String Implements ICommand.Name
        Get
            Return "deposit of " & Amount & " to " & Account.Id
        End Get
    End Property

    Public Sub Execute() Implements ICommand.Execute
        Account.Deposit(Amount)
    End Sub

    Public Sub Undo() Implements ICommand.Undo
        Account.Withdraw(Amount)
    End Sub

    Public Sub Redo() Implements ICommand.Redo
        Execute()
    End Sub

    Public Sub Collapse(aCommand As ICommand) Implements ICommand.Collapse
        _Amount += DirectCast(aCommand, DepositCommand).Amount
    End Sub
End Class
