﻿Public Class Form1
    'https://www.youtube.com/watch?v=83dcoRgE0UI
    'https://github.com/javadude/patterns.session4/tree/master/Command
    'http://www.javadude.com/articles/patterns/index.html

    Private WithEvents Account1 As Account
    Private WithEvents Account2 As Account
    Private WithEvents UndoManager As UndoManager

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Account1 = New Account(1)
        Account2 = New Account(2)
        UndoManager = New UndoManager()
    End Sub

    Private Sub BtnDeposit10Acc1_Click(sender As Object, e As EventArgs) Handles BtnDeposit10Acc1.Click
        UndoManager.Execute(New DepositCommand(Account1, 10))
    End Sub

    Private Sub BtnDeposit10Acc2_Click(sender As Object, e As EventArgs) Handles BtnDeposit10Acc2.Click
        UndoManager.Execute(New DepositCommand(Account2, 10))
    End Sub

    Private Sub BtnWithdraw10Acc1_Click(sender As Object, e As EventArgs) Handles BtnWithdraw10Acc1.Click
        UndoManager.Execute(New WithdrawCommand(Account1, 10))
    End Sub

    Private Sub BtnWithdraw10Acc2_Click(sender As Object, e As EventArgs) Handles BtnWithdraw10Acc2.Click
        UndoManager.Execute(New WithdrawCommand(Account2, 10))
    End Sub

    Private Sub BtnTransfer10fromAcc1toAcc2_Click(sender As Object, e As EventArgs) Handles BtnTransfer10fromAcc1toAcc2.Click
        UndoManager.Execute(New TransferCommand(Account1, Account2, 10))
    End Sub

    Private Sub BtnTransfer10fromAcc2toAcc1_Click(sender As Object, e As EventArgs) Handles BtnTransfer10fromAcc2toAcc1.Click
        UndoManager.Execute(New TransferCommand(Account2, Account1, 10))
    End Sub

    Private Sub BtnUndo_Click(sender As Object, e As EventArgs) Handles BtnUndo.Click
        UndoManager.Undo()
    End Sub

    Private Sub BtnRedo_Click(sender As Object, e As EventArgs) Handles BtnRedo.Click
        UndoManager.Redo()
    End Sub

    Private Sub Account1_PropertyChange() Handles Account1.PropertyChange
        LblAccount1Id.Text = "Account #" & Account1.Id.ToString()
        LblAccount1Balance.Text = "Balance $" & Account1.Balance.ToString()
    End Sub

    Private Sub Account2_PropertyChange() Handles Account2.PropertyChange
        LblAccount2Id.Text = "Account #" & Account2.Id.ToString()
        LblAccount2Balance.Text = "Balance $" & Account2.Balance.ToString()
    End Sub

    Private Sub UndoManager_PropertyChange() Handles UndoManager.PropertyChange
        BtnUndo.Enabled = UndoManager.IsUndoAvailable
        BtnUndo.Text = "Undo " & UndoManager.UndoName
        BtnRedo.Enabled = UndoManager.IsRedoAvailable
        BtnRedo.Text = "Redo " & UndoManager.RedoName
    End Sub
End Class
