﻿Imports UndoRedoCommand

Public Class TransferCommand
    Implements ICommand
    Private _CompositeCommand As CompositeCommand

    Public Sub New(aFrom As Account, aTo As Account, ByVal aAmount As Double)
        _CompositeCommand = New CompositeCommand("Transfer " & aAmount & " from acc " & aFrom.Id & " to " & aTo.Id,
                    New WithdrawCommand(aFrom, aAmount), New DepositCommand(aTo, aAmount))
    End Sub

    Public ReadOnly Property IsCollapsible(aCommand As ICommand) As Boolean Implements ICommand.IsCollapsible
        Get
            Return False
        End Get
    End Property

    Public ReadOnly Property Name As String Implements ICommand.Name
        Get
            Return _CompositeCommand.Name
        End Get
    End Property

    Public Sub Execute() Implements ICommand.Execute
        _CompositeCommand.Execute()
    End Sub

    Public Sub Undo() Implements ICommand.Undo
        _CompositeCommand.Undo()
    End Sub

    Public Sub Redo() Implements ICommand.Redo
        _CompositeCommand.Redo()
    End Sub

    Public Sub Collapse(aCommand As ICommand) Implements ICommand.Collapse
        'Throw New NotImplementedException()
    End Sub
End Class


'Public Class TransferCommand
'    Implements ICommand
'    Private _From As Account
'    Private _To As Account
'    Private _Amount As Double

'    Public Sub New(aFrom As Account, aTo As Account, ByVal aAmount As Double)
'        _From = aFrom
'        _To = aTo
'        _Amount = aAmount
'    End Sub

'    Public ReadOnly Property IsCollapsible(aCommand As ICommand) As Boolean Implements ICommand.IsCollapsible
'        Get
'            Return False
'        End Get
'    End Property

'    Public ReadOnly Property Name As String Implements ICommand.Name
'        Get
'            Return "Transfer " & _Amount & " from account " & _From.Id & " to account " & _To.Id
'        End Get
'    End Property

'    Public Sub Execute() Implements ICommand.Execute
'        _From.Withdraw(_Amount)
'        _To.Deposit(_Amount)
'    End Sub

'    Public Sub Undo() Implements ICommand.Undo
'        _To.Withdraw(_Amount)
'        _From.Deposit(_Amount)
'    End Sub

'    Public Sub Redo() Implements ICommand.Redo
'        Execute()
'    End Sub

'    Public Sub Collapse(aCommand As ICommand) Implements ICommand.Collapse
'        'Throw New NotImplementedException()
'    End Sub
'End Class
